3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
19 if test -n "$OPTIONS_SPEC"; then
26 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
27 parseopt_extra
="--keep-dashdash"
30 echo "$OPTIONS_SPEC" |
31 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
36 die
"Usage: $0 $USAGE"
39 if [ -z "$LONG_USAGE" ]
41 LONG_USAGE
="Usage: $0 $USAGE"
43 LONG_USAGE
="Usage: $0 $USAGE
49 -h|
--h|
--he|
--hel|
--help)
56 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
58 GIT_REFLOG_ACTION
="$*"
59 export GIT_REFLOG_ACTION
64 : "${GIT_EDITOR:=$(git config core.editor)}"
65 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
66 case "$GIT_EDITOR,$TERM" in
68 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
69 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
70 echo >&2 "Please set one of these variables to an appropriate"
71 echo >&2 "editor or run $0 with options that will not cause an"
72 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
76 eval "${GIT_EDITOR:=vi}" '"$@"'
79 is_bare_repository
() {
80 git rev-parse
--is-bare-repository
84 cdup
=$
(git rev-parse
--show-cdup)
88 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
94 require_work_tree
() {
95 test $
(git rev-parse
--is-inside-work-tree) = true ||
96 die
"fatal: $0 cannot be used without a working tree."
99 get_author_ident_from_commit
() {
102 s/'\''/'\''\\'\'\''/g
104 s/^author \([^<]*\) <[^>]*> .*$/\1/
106 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
109 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
111 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
114 s/^author [^<]* <[^>]*> \(.*\)$/\1/
116 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
121 encoding=$(git config i18n.commitencoding || echo UTF-8)
122 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
123 LANG=C LC_ALL=C sed -ne "$pick_author_script"
126 # Make sure we are in a valid repository of a vintage we understand,
127 # if we require to be in a git repository.
128 if test -z "$NONGIT_OK"
130 GIT_DIR=$(git rev-parse --git-dir) || exit
131 if [ -z "$SUBDIRECTORY_OK" ]
133 test -z "$(git rev-parse --show-cdup)" || {
135 echo >&2 "You need to run this command from the toplevel of the working tree."
139 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
140 echo >&2 "Unable to determine absolute path of git directory"
143 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}